{ File    : $URL: file:///D:/SVN/svnDelphi/branches/A%20New%20Beginning/VISExt/servicing/src/convert/Compr.pas $
  Author  : $Author: Deniz Oezmen $
  Changed : $Date: 2017-09-26 17:56:44 +0200 (Di, 26 Sep 2017) $
  Revision: $Rev: 467 $

  Visionaire Engine extractor compression routines
}
unit Compr;

interface

uses
  Shared;
      
function Decompress(const InBuffer: TBuffer; InOfs, InLen: Longint;
  var OutBuffer: TBuffer; OutOfs, OutLen: Longint): Boolean;
function Compress(const InBuffer: TBuffer; out OutBuffer: TBuffer): Boolean;

implementation

uses
  ZLib;

function Decompress(const InBuffer: TBuffer; InOfs, InLen: Longint;
  var OutBuffer: TBuffer; OutOfs, OutLen: Longint): Boolean;
var
  DecompSize: Longint;
  TempBuffer: Pointer;
begin
  // standard ZLib decompression
  DecompressBuf(@InBuffer[InOfs], InLen, OutLen, TempBuffer,
    DecompSize);

  Result := (DecompSize = OutLen);
  if Result then
    Move(TempBuffer^, OutBuffer[OutOfs], DecompSize);

  FreeMem(TempBuffer, DecompSize)
end;

function Compress(const InBuffer: TBuffer; out OutBuffer: TBuffer): Boolean;
var
  CompSize  : Longint;
  TempBuffer: Pointer;
begin
  // standard ZLib compression
  CompressBuf(@InBuffer[0], Length(InBuffer), TempBuffer, CompSize);

  Result := (CompSize >= 0);
  if Result then
  begin
    SetLength(OutBuffer, CompSize);
    Move(TempBuffer^, OutBuffer[0], CompSize)
  end;

  FreeMem(TempBuffer, CompSize)
end;

end.
