{ File    : $URL: file:///D:/SVN/svnDelphi/branches/A%20New%20Beginning/VISExt/servicing/src/shared/Shared.pas $
  Author  : $Author: Deniz Oezmen $
  Changed : $Date: 2021-08-26 22:41:37 +0200 (Do, 26 Aug 2021) $
  Revision: $Rev: 600 $

  Visionaire Engine extractor common types and functions
}
unit Shared;

interface

type
  TBuffer = array of Byte;

var
  BigEndian: Boolean;

function OpenInFile(var InFile: file; InName: AnsiString): Boolean;
function OpenOutFile(var OutFile: file; OutName: UTF8String): Boolean;
procedure SwitchEndian(var Val: Longword; Force: Boolean = False);

implementation

uses
  SysUtils;

function OpenInFile(var InFile: file; InName: AnsiString): Boolean;
begin
  FileMode := fmShareDenyWrite;
  AssignFile(InFile, InName);

  {$I-}
  Reset(InFile, 1);
  {$I+}
  Result := (IOResult = 0)
end;

function OpenOutFile(var OutFile: file; OutName: UTF8String): Boolean;
var
  AnsiName,
  Dir     : AnsiString;
begin
  AnsiName := Utf8ToAnsi(OutName);

  // first create the directory portion of the output file
  Dir := ExtractFileDir(ExpandFileName(AnsiName));
  ForceDirectories(Dir);

  // open the output file
  FileMode := fmOpenWrite;
  AssignFile(OutFile, AnsiName);

  {$I-}
  Rewrite(OutFile, 1);
  {$I+}
  Result := (IOResult = 0)
end;

procedure SwitchEndian(var Val: Longword; Force: Boolean = False);
begin
  if BigEndian or Force then
    Val := (Val shr 24) or
           ((Val shr 8) and $0000ff00) or
           ((Val shl 8) and $00ff0000) or
           (Val shl 24)
end;

end.
 