{ File    : $URL: file:///D:/SVN/svnDelphi/branches/A%20New%20Beginning/VISExt/servicing/src/shared/VISFmt.pas $
  Author  : $Author: Deniz Oezmen $
  Changed : $Date: 2017-09-26 18:27:27 +0200 (Di, 26 Sep 2017) $
  Revision: $Rev: 469 $

  Visionaire Engine extractor format definitions
}
unit VISFmt;

interface

const
  VISHeaderID = 'VIS3';
  DirHeaderID = 'HDR';
  DirFooterID = 'END';
  BinaryXMLID = 'VBIN';

  Flag_MainXML1      = $00000001;
  Flag_CryptDefault  = $00000002;
  Flag_CryptImage    = $00000008;
  Flag_MainXML2      = $00000010;

  Flag_BinaryMainXML = $80000000; // Note: These flags are not actually found in
  Flag_VEBMainXML    = $40000000; // a game archive. We just use them
  Flag_VEDMainXML    = $20000000; // internally.

  Flag_TextMainXML   = Flag_MainXML1 or Flag_MainXML2 or Flag_VEDMainXML;
  Flag_AnyMainXML    = Flag_TextMainXML or Flag_BinaryMainXML or
                       Flag_VEBMainXML;

  CompChainEnd: Longword = $ffeeffee;

type
  TVISHeader = packed record
    ID      : array[0..3] of Char;
    NumFiles: Longword;
  end;

  TDirHeader = packed record
    ID: array[0..2] of Char;
  end;

  TDirFooter = packed record
    ID: array[0..2] of Char;
  end;

  TDirEntry = packed record
    Offset    : Longword;
    CompSize  : Longword;
    UncompSize: Longword;
    Flags     : Longword;
  end;

  TDirEntries = packed array of TDirEntry;

  TXMLCompBlockHeader = packed record
    UncompSize: Longword;
    CompSize  : Longword;
  end;

  TBinaryXMLCompHeader = packed record
    ID        : array[0..3] of Char;
    Unknown   : Longword; // number of objects, links, ...?
    UncompSize: Longword;
    CompSize  : Longword;
  end;

implementation

end.
